package parsecheck.oireland.tripod.com;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    private static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "parsecheck.oireland.tripod.com", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "parsecheck.oireland.tripod.com", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
		processBA.raiseEvent(_activity, "activity_pause", activityBA.activity.isFinishing());
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
	
public static class _wiki{
boolean IsInitialized;
String title;
String distance;
String summary;
public void Initialize() {
IsInitialized = true;
title = "";
distance = "";
summary = "";
}}public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _timer2 = null;
public static anywheresoftware.b4a.gps.GPS _gps1 = null;
public static double _lat = 0;
public static double _lon = 0;
public static double _course = 0;
public static String _googleurl = "";
public static String _yahoourl = "";
public static String _geonamesurl = "";
public static String _googlecountry = "";
public static String _yahoocountry = "";
public static String _state = "";
public static String _circle = "";
public static String _postcode = "";
public static String _place = "";
public static String _googlestreet = "";
public static String _yahoostreet = "";
public static anywheresoftware.b4a.http.HttpClientWrapper _httpclientgoogle = null;
public static anywheresoftware.b4a.http.HttpClientWrapper _httpclientyahoo = null;
public static anywheresoftware.b4a.http.HttpClientWrapper _httpclientgeonames = null;
public static anywheresoftware.b4a.objects.SaxParser _googleparser = null;
public static anywheresoftware.b4a.objects.SaxParser _yahooparser = null;
public static anywheresoftware.b4a.objects.SaxParser _geonamesparser = null;
public static anywheresoftware.b4a.objects.streams.File.InputStreamWrapper _googleresult = null;
public static anywheresoftware.b4a.objects.streams.File.InputStreamWrapper _yahooresult = null;
public static anywheresoftware.b4a.objects.streams.File.InputStreamWrapper _geonamesresult = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static String _address = "";
public static String _googlemsgbox = "";
public static String _yahoomsgbox = "";
public static String _subadministrativearea = "";
public static String _administrativearea = "";
public static String _localityname = "";
public static String _county = "";
public static String _city = "";
public static String _neighborhood = "";
public static String _countrycode = "";
public static anywheresoftware.b4a.objects.collections.List _adrlist = null;
public static anywheresoftware.b4a.obejcts.TTS _tts1 = null;
public static String _spokenword = "";
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _backwards = null;
public static boolean _gps_control = false;
public static String  _activity_create(boolean _firsttime) throws Exception{
main._wiki _w = null;
 BA.debugLineNum = 37;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 BA.debugLineNum = 38;BA.debugLine="GPS1.Initialize(\"GPS\")";
_gps1.Initialize("GPS");
 BA.debugLineNum = 39;BA.debugLine="googleparser.Initialize";
_googleparser.Initialize(processBA);
 BA.debugLineNum = 40;BA.debugLine="yahooparser.Initialize";
_yahooparser.Initialize(processBA);
 BA.debugLineNum = 41;BA.debugLine="geonamesparser.Initialize";
_geonamesparser.Initialize(processBA);
 BA.debugLineNum = 42;BA.debugLine="HttpClientgoogle.Initialize(\"HttpClientgoogle\")";
_httpclientgoogle.Initialize("HttpClientgoogle");
 BA.debugLineNum = 43;BA.debugLine="HttpClientyahoo.Initialize(\"HttpClientyahoo\")";
_httpclientyahoo.Initialize("HttpClientyahoo");
 BA.debugLineNum = 44;BA.debugLine="HttpClientgeonames.Initialize(\"HttpClientgeonames\")";
_httpclientgeonames.Initialize("HttpClientgeonames");
 BA.debugLineNum = 45;BA.debugLine="File.Copy(File.DirAssets,\"settings.txt\",File.DirInternal,\"settings.txt\")";
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"settings.txt",anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.txt");
 BA.debugLineNum = 46;BA.debugLine="File.Copy(File.DirAssets,\"fonttype.txt\",File.DirInternal,\"fonttype.txt\")";
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"fonttype.txt",anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"fonttype.txt");
 BA.debugLineNum = 47;BA.debugLine="File.Copy(File.DirAssets,\"voice.txt\",File.DirInternal,\"voice.txt\")";
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"voice.txt",anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"voice.txt");
 BA.debugLineNum = 48;BA.debugLine="End If";
};
 BA.debugLineNum = 49;BA.debugLine="Dim w As wiki";
_w = new main._wiki();
 BA.debugLineNum = 50;BA.debugLine="adrlist.Initialize";
_adrlist.Initialize();
 BA.debugLineNum = 51;BA.debugLine="Timer1.Initialize(\"Timer1\",3000)";
_timer1.Initialize(processBA,"Timer1",(long)(3000));
 BA.debugLineNum = 52;BA.debugLine="Timer2.Initialize(\"Timer2\",1000)'Timer for Reverse Geocoding(updating every 3 seconds)'";
_timer2.Initialize(processBA,"Timer2",(long)(1000));
 BA.debugLineNum = 53;BA.debugLine="label1.Initialize(\"label1\")";
mostCurrent._label1.Initialize(mostCurrent.activityBA,"label1");
 BA.debugLineNum = 54;BA.debugLine="Activity.AddMenuItem2(\"yahoo/google\",\"settings\",LoadBitmap(File.DirAssets, \"advancedsettings48X48.png\"))";
mostCurrent._activity.AddMenuItem2("yahoo/google","settings",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"advancedsettings48X48.png").getObject()));
 BA.debugLineNum = 55;BA.debugLine="Activity.AddMenuItem2(\"mirrored/not\",\"settings2\",LoadBitmap(File.DirAssets, \"mirror48X48.png\"))";
mostCurrent._activity.AddMenuItem2("mirrored/not","settings2",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"mirror48X48.png").getObject()));
 BA.debugLineNum = 56;BA.debugLine="Activity.AddMenuItem2(\"voice on/off\",\"settings3\",LoadBitmap(File.DirAssets, \"kmix48X48.png\"))";
mostCurrent._activity.AddMenuItem2("voice on/off","settings3",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"kmix48X48.png").getObject()));
 BA.debugLineNum = 57;BA.debugLine="Activity.AddMenuItem2(\"Full Info\",\"gpsinfo\",LoadBitmap(File.DirAssets, \"info48X48.png\"))";
mostCurrent._activity.AddMenuItem2("Full Info","gpsinfo",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"info48X48.png").getObject()));
 BA.debugLineNum = 58;BA.debugLine="Activity.AddMenuItem2(\"Help\",\"help\",LoadBitmap(File.DirAssets, \"khelpcenter48X48.png\"))";
mostCurrent._activity.AddMenuItem2("Help","help",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"khelpcenter48X48.png").getObject()));
 BA.debugLineNum = 60;BA.debugLine="Activity.AddMenuItem2(\"Quit\",\"Quit\",LoadBitmap(File.DirAssets, \"exit48x48.png\"))";
mostCurrent._activity.AddMenuItem2("Quit","Quit",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"exit48x48.png").getObject()));
 BA.debugLineNum = 61;BA.debugLine="Activity.AddView(label1,1,1,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._label1.getObject()),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 62;BA.debugLine="Timer1.Enabled=True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 BA.debugLineNum = 76;BA.debugLine="TTS1.Release";
_tts1.Release();
 BA.debugLineNum = 77;BA.debugLine="GPS1.Stop";
_gps1.Stop();
 BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 BA.debugLineNum = 65;BA.debugLine="If GPS1.GPSEnabled = False Then";
if (_gps1.getGPSEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 66;BA.debugLine="ToastMessageShow(\"Please enable the GPS device.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Please enable the GPS device.",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 67;BA.debugLine="StartActivity(GPS1.LocationSettingsIntent) 'Will open the relevant settings screen.";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(_gps1.getLocationSettingsIntent()));
 BA.debugLineNum = 68;BA.debugLine="Else";
}else {
 BA.debugLineNum = 69;BA.debugLine="GPS1.Start(0, 0) 'Listen to GPS with no filters.";
_gps1.Start(processBA,(long)(0),(float)(0));
 BA.debugLineNum = 70;BA.debugLine="End If";
};
 BA.debugLineNum = 71;BA.debugLine="If TTS1.IsInitialized = False Then";
if (_tts1.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 72;BA.debugLine="TTS1.Initialize(\"TTS1\")";
_tts1.Initialize(processBA,"TTS1");
 BA.debugLineNum = 73;BA.debugLine="End If";
};
 BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _geonamesparser_endelement(String _uri,String _name,anywheresoftware.b4a.keywords.StringBuilderWrapper _text) throws Exception{
main._wiki _w = null;
 BA.debugLineNum = 208;BA.debugLine="Dim w As wiki";
_w = new main._wiki();
 BA.debugLineNum = 209;BA.debugLine="w = adrlist.Get(adrlist.Size - 1)";
_w = (main._wiki)(_adrlist.Get((int)(_adrlist.getSize()-1)));
 BA.debugLineNum = 210;BA.debugLine="Select Name";
switch (BA.switchObjectToInt(_name,"title","distance","summary")) {
case 0:
 BA.debugLineNum = 212;BA.debugLine="w.title = Text.ToString";
_w.title = _text.ToString();
 BA.debugLineNum = 213;BA.debugLine="Case \"distance\"";
break;
case 1:
 BA.debugLineNum = 214;BA.debugLine="w.distance = Text.ToString";
_w.distance = _text.ToString();
 BA.debugLineNum = 215;BA.debugLine="Case \"summary\"";
break;
case 2:
 BA.debugLineNum = 216;BA.debugLine="w.summary = Text.ToString";
_w.summary = _text.ToString();
 BA.debugLineNum = 217;BA.debugLine="End Select";
break;
}
;
 BA.debugLineNum = 218;BA.debugLine="End Sub";
return "";
}
public static String  _geonamesparser_startelement(String _uri,String _name,anywheresoftware.b4a.objects.SaxParser.AttributesWrapper _attributes) throws Exception{
main._wiki _w = null;
 BA.debugLineNum = 201;BA.debugLine="If Name = \"entry\" Then";
if ((_name).equals("entry")) { 
 BA.debugLineNum = 202;BA.debugLine="Dim w As wiki";
_w = new main._wiki();
 BA.debugLineNum = 203;BA.debugLine="w.Initialize";
_w.Initialize();
 BA.debugLineNum = 204;BA.debugLine="adrlist.Add(w)";
_adrlist.Add((Object)(_w));
 BA.debugLineNum = 205;BA.debugLine="End If";
};
 BA.debugLineNum = 206;BA.debugLine="End Sub";
return "";
}
public static String  _georesponse_streamfinish(boolean _success,int _taskid) throws Exception{
 BA.debugLineNum = 140;BA.debugLine="If Success = False Then";
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 141;BA.debugLine="ToastMessageShow(\"Error\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 142;BA.debugLine="End If";
};
 BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _gettextsize() throws Exception{
String _geocodename = "";
String _fonttype = "";
String _localaddress = "";
anywheresoftware.b4a.objects.drawable.CanvasWrapper _canvass1 = null;
float _maxwidth = 0f;
float _maxheight = 0f;
float _sizeoftext = 0f;
float _textheight = 0f;
float _textwidth = 0f;
float _i = 0f;
int _flag = 0;
String _oldaddress = "";
main._wiki _thingymabob = null;
String _flag3 = "";
String _voicesetting = "";
 BA.debugLineNum = 253;BA.debugLine="Dim geocodename As String";
_geocodename = "";
 BA.debugLineNum = 254;BA.debugLine="Dim fonttype As String";
_fonttype = "";
 BA.debugLineNum = 255;BA.debugLine="Dim localaddress As String";
_localaddress = "";
 BA.debugLineNum = 256;BA.debugLine="geocodename=File.GetText(File.DirInternal,\"settings.txt\")";
_geocodename = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.txt");
 BA.debugLineNum = 257;BA.debugLine="fonttype=File.GetText(File.DirInternal,\"fonttype.txt\")";
_fonttype = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"fonttype.txt");
 BA.debugLineNum = 258;BA.debugLine="Dim canvass1 As Canvas";
_canvass1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 BA.debugLineNum = 259;BA.debugLine="Dim maxwidth As Float";
_maxwidth = 0f;
 BA.debugLineNum = 260;BA.debugLine="Dim maxheight As Float";
_maxheight = 0f;
 BA.debugLineNum = 261;BA.debugLine="Dim sizeoftext As Float";
_sizeoftext = 0f;
 BA.debugLineNum = 262;BA.debugLine="Dim textheight As Float";
_textheight = 0f;
 BA.debugLineNum = 263;BA.debugLine="Dim textwidth As Float";
_textwidth = 0f;
 BA.debugLineNum = 264;BA.debugLine="Dim i As Float";
_i = 0f;
 BA.debugLineNum = 265;BA.debugLine="Dim flag As Int";
_flag = 0;
 BA.debugLineNum = 266;BA.debugLine="Dim oldaddress As String";
_oldaddress = "";
 BA.debugLineNum = 267;BA.debugLine="If geocodename=\"yahoo\" Then";
if ((_geocodename).equals("yahoo")) { 
 BA.debugLineNum = 268;BA.debugLine="localaddress=neighborhood";
_localaddress = _neighborhood;
 BA.debugLineNum = 269;BA.debugLine="End If";
};
 BA.debugLineNum = 270;BA.debugLine="If geocodename=\"google\" Then";
if ((_geocodename).equals("google")) { 
 BA.debugLineNum = 271;BA.debugLine="localaddress=googlestreet";
_localaddress = _googlestreet;
 BA.debugLineNum = 272;BA.debugLine="End If";
};
 BA.debugLineNum = 273;BA.debugLine="If geocodename=\"geonames\" Then";
if ((_geocodename).equals("geonames")) { 
 BA.debugLineNum = 274;BA.debugLine="If adrlist.Size > 0 Then";
if (_adrlist.getSize()>(int)(0)) { 
 BA.debugLineNum = 275;BA.debugLine="Dim thingymabob As wiki";
_thingymabob = new main._wiki();
 BA.debugLineNum = 276;BA.debugLine="thingymabob=adrlist.Get(0)";
_thingymabob = (main._wiki)(_adrlist.Get((int)(0)));
 BA.debugLineNum = 277;BA.debugLine="localaddress=thingymabob.title";
_localaddress = _thingymabob.title;
 BA.debugLineNum = 278;BA.debugLine="End If";
};
 BA.debugLineNum = 279;BA.debugLine="End If";
};
 BA.debugLineNum = 280;BA.debugLine="maxwidth=Activity.Width";
_maxwidth = (float)(mostCurrent._activity.getWidth());
 BA.debugLineNum = 281;BA.debugLine="maxheight=Activity.Height";
_maxheight = (float)(mostCurrent._activity.getHeight());
 BA.debugLineNum = 282;BA.debugLine="canvass1.Initialize(activity)";
_canvass1.Initialize((android.view.View)(mostCurrent._activity.getObject()));
 BA.debugLineNum = 283;BA.debugLine="flag=1";
_flag = (int)(1);
 BA.debugLineNum = 284;BA.debugLine="If fonttype=\"backwards\" Then";
if ((_fonttype).equals("backwards")) { 
 BA.debugLineNum = 285;BA.debugLine="For i=1 To 1000";
{
final double step273 = 1;
final double limit273 = (float)(1000);
for (_i = (float)(1); (step273 > 0 && _i <= limit273) || (step273 < 0 && _i >= limit273); _i += step273) {
 BA.debugLineNum = 286;BA.debugLine="textheight=canvass1.MeasureStringHeight(localaddress,backwards,i)";
_textheight = _canvass1.MeasureStringHeight(_localaddress,(android.graphics.Typeface)(mostCurrent._backwards.getObject()),_i);
 BA.debugLineNum = 287;BA.debugLine="textwidth=canvass1.MeasureStringWidth(localaddress,backwards,i)";
_textwidth = _canvass1.MeasureStringWidth(_localaddress,(android.graphics.Typeface)(mostCurrent._backwards.getObject()),_i);
 BA.debugLineNum = 288;BA.debugLine="If flag=1 Then";
if (_flag==(int)(1)) { 
 BA.debugLineNum = 289;BA.debugLine="If textheight >= maxheight OR textwidth >= maxwidth Then";
if (_textheight>=_maxheight || _textwidth>=_maxwidth) { 
 BA.debugLineNum = 290;BA.debugLine="sizeoftext=i-1";
_sizeoftext = (float)(_i-1);
 BA.debugLineNum = 291;BA.debugLine="flag=2";
_flag = (int)(2);
 BA.debugLineNum = 292;BA.debugLine="End If";
};
 BA.debugLineNum = 293;BA.debugLine="End If";
};
 BA.debugLineNum = 294;BA.debugLine="Next";
}
};
 BA.debugLineNum = 295;BA.debugLine="label1.Initialize(\"label1\")";
mostCurrent._label1.Initialize(mostCurrent.activityBA,"label1");
 BA.debugLineNum = 296;BA.debugLine="Activity.AddView(Label1,1,1,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._label1.getObject()),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 297;BA.debugLine="Label1.Typeface=backwards";
mostCurrent._label1.setTypeface((android.graphics.Typeface)(mostCurrent._backwards.getObject()));
 BA.debugLineNum = 298;BA.debugLine="Label1.TextSize=sizeoftext";
mostCurrent._label1.setTextSize(_sizeoftext);
 BA.debugLineNum = 299;BA.debugLine="oldaddress=localaddress";
_oldaddress = _localaddress;
 BA.debugLineNum = 300;BA.debugLine="localaddress=Reversestring(localaddress)";
_localaddress = _reversestring(_localaddress);
 BA.debugLineNum = 301;BA.debugLine="Else";
}else {
 BA.debugLineNum = 302;BA.debugLine="For i=1 To 1000";
{
final double step290 = 1;
final double limit290 = (float)(1000);
for (_i = (float)(1); (step290 > 0 && _i <= limit290) || (step290 < 0 && _i >= limit290); _i += step290) {
 BA.debugLineNum = 303;BA.debugLine="textheight=canvass1.MeasureStringHeight(localaddress,Typeface.DEFAULT_BOLD,i)";
_textheight = _canvass1.MeasureStringHeight(_localaddress,anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,_i);
 BA.debugLineNum = 304;BA.debugLine="textwidth=canvass1.MeasureStringWidth(localaddress,Typeface.DEFAULT_BOLD,i)";
_textwidth = _canvass1.MeasureStringWidth(_localaddress,anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,_i);
 BA.debugLineNum = 305;BA.debugLine="If flag=1 Then";
if (_flag==(int)(1)) { 
 BA.debugLineNum = 306;BA.debugLine="If textheight >= maxheight OR textwidth >= maxwidth Then";
if (_textheight>=_maxheight || _textwidth>=_maxwidth) { 
 BA.debugLineNum = 307;BA.debugLine="sizeoftext=i-1";
_sizeoftext = (float)(_i-1);
 BA.debugLineNum = 308;BA.debugLine="flag=2";
_flag = (int)(2);
 BA.debugLineNum = 309;BA.debugLine="End If";
};
 BA.debugLineNum = 310;BA.debugLine="End If";
};
 BA.debugLineNum = 311;BA.debugLine="Next";
}
};
 BA.debugLineNum = 312;BA.debugLine="label1.Initialize(\"label1\")";
mostCurrent._label1.Initialize(mostCurrent.activityBA,"label1");
 BA.debugLineNum = 313;BA.debugLine="Activity.AddView(Label1,1,1,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._label1.getObject()),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 314;BA.debugLine="Label1.Typeface=Typeface.DEFAULT_BOLD";
mostCurrent._label1.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 BA.debugLineNum = 315;BA.debugLine="Label1.TextSize=sizeoftext";
mostCurrent._label1.setTextSize(_sizeoftext);
 BA.debugLineNum = 316;BA.debugLine="End If";
};
 BA.debugLineNum = 317;BA.debugLine="Label1.Color=Colors.Black";
mostCurrent._label1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 318;BA.debugLine="Label1.Text=localaddress";
mostCurrent._label1.setText((Object)(_localaddress));
 BA.debugLineNum = 319;BA.debugLine="Dim flag3 As String";
_flag3 = "";
 BA.debugLineNum = 320;BA.debugLine="flag3=Label1.Text";
_flag3 = mostCurrent._label1.getText();
 BA.debugLineNum = 321;BA.debugLine="voicesetting=File.GetText(File.DirInternal,\"voice.txt\")";
_voicesetting = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"voice.txt");
 BA.debugLineNum = 322;BA.debugLine="If flag3.Length > 0 AND voicesetting=\"on\" Then";
if (_flag3.length()>(int)(0) && (_voicesetting).equals("on")) { 
 BA.debugLineNum = 323;BA.debugLine="If flag3<>spokenword Then";
if ((_flag3).equals(_spokenword) == false) { 
 BA.debugLineNum = 324;BA.debugLine="If fonttype=\"backwards\" Then";
if ((_fonttype).equals("backwards")) { 
 BA.debugLineNum = 325;BA.debugLine="TTS1.Speak(oldaddress, True)";
_tts1.Speak(_oldaddress,anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 326;BA.debugLine="spokenword=flag3";
_spokenword = _flag3;
 BA.debugLineNum = 327;BA.debugLine="Else";
}else {
 BA.debugLineNum = 328;BA.debugLine="TTS1.Speak(Label1.Text, True)";
_tts1.Speak(mostCurrent._label1.getText(),anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 329;BA.debugLine="spokenword=flag3";
_spokenword = _flag3;
 BA.debugLineNum = 330;BA.debugLine="End If";
};
 BA.debugLineNum = 331;BA.debugLine="End If";
};
 BA.debugLineNum = 332;BA.debugLine="End If";
};
 BA.debugLineNum = 333;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 BA.debugLineNum = 30;BA.debugLine="Dim label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 31;BA.debugLine="Dim backwards As Typeface";
mostCurrent._backwards = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
 BA.debugLineNum = 32;BA.debugLine="Dim GPS_Control As Boolean";
_gps_control = false;
 BA.debugLineNum = 33;BA.debugLine="backwards=Typeface.LoadFromAssets(\"backrg__.ttf\")";
mostCurrent._backwards.setObject((android.graphics.Typeface)(anywheresoftware.b4a.keywords.Common.Typeface.LoadFromAssets("backrg__.ttf")));
 BA.debugLineNum = 34;BA.debugLine="GPS_Control=True";
_gps_control = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _googleparser_endelement(String _uri,String _name,anywheresoftware.b4a.keywords.StringBuilderWrapper _text) throws Exception{
 BA.debugLineNum = 145;BA.debugLine="If googleparser.Parents.IndexOf(\"Placemark\") > -1 Then";
if (_googleparser.Parents.IndexOf((Object)("Placemark"))>(int)(-1)) { 
 BA.debugLineNum = 146;BA.debugLine="If googleparser.Parents.IndexOf(\"Country\") > -1 Then	'country'";
if (_googleparser.Parents.IndexOf((Object)("Country"))>(int)(-1)) { 
 BA.debugLineNum = 147;BA.debugLine="If Name = \"CountryName\" Then";
if ((_name).equals("CountryName")) { 
 BA.debugLineNum = 148;BA.debugLine="googlecountry=Text.ToString";
_googlecountry = _text.ToString();
 BA.debugLineNum = 149;BA.debugLine="End If";
};
 BA.debugLineNum = 150;BA.debugLine="End If";
};
 BA.debugLineNum = 151;BA.debugLine="If googleparser.Parents.IndexOf(\"AdministrativeArea\") > -1 Then	'state'";
if (_googleparser.Parents.IndexOf((Object)("AdministrativeArea"))>(int)(-1)) { 
 BA.debugLineNum = 152;BA.debugLine="If Name = \"AdministrativeAreaName\" Then";
if ((_name).equals("AdministrativeAreaName")) { 
 BA.debugLineNum = 153;BA.debugLine="administrativearea=Text.ToString";
_administrativearea = _text.ToString();
 BA.debugLineNum = 154;BA.debugLine="End If";
};
 BA.debugLineNum = 155;BA.debugLine="End If";
};
 BA.debugLineNum = 156;BA.debugLine="If googleparser.Parents.IndexOf(\"SubAdministrativeArea\") > -1 Then	'circle'";
if (_googleparser.Parents.IndexOf((Object)("SubAdministrativeArea"))>(int)(-1)) { 
 BA.debugLineNum = 157;BA.debugLine="If Name = \"SubAdministrativeAreaName\" Then";
if ((_name).equals("SubAdministrativeAreaName")) { 
 BA.debugLineNum = 158;BA.debugLine="subadministrativearea=Text.ToString";
_subadministrativearea = _text.ToString();
 BA.debugLineNum = 159;BA.debugLine="End If";
};
 BA.debugLineNum = 160;BA.debugLine="End If";
};
 BA.debugLineNum = 161;BA.debugLine="If googleparser.Parents.IndexOf(\"Locality\") > -1 Then		'place'";
if (_googleparser.Parents.IndexOf((Object)("Locality"))>(int)(-1)) { 
 BA.debugLineNum = 162;BA.debugLine="If Name = \"LocalityName\" Then";
if ((_name).equals("LocalityName")) { 
 BA.debugLineNum = 163;BA.debugLine="localityname=Text.ToString";
_localityname = _text.ToString();
 BA.debugLineNum = 164;BA.debugLine="End If";
};
 BA.debugLineNum = 165;BA.debugLine="End If";
};
 BA.debugLineNum = 166;BA.debugLine="If googleparser.Parents.IndexOf(\"Thoroughfare\") > -1 Then		'street, housenumber'";
if (_googleparser.Parents.IndexOf((Object)("Thoroughfare"))>(int)(-1)) { 
 BA.debugLineNum = 167;BA.debugLine="If Name = \"ThoroughfareName\" Then";
if ((_name).equals("ThoroughfareName")) { 
 BA.debugLineNum = 168;BA.debugLine="googlestreet=Text.ToString";
_googlestreet = _text.ToString();
 BA.debugLineNum = 169;BA.debugLine="End If";
};
 BA.debugLineNum = 170;BA.debugLine="End If";
};
 BA.debugLineNum = 171;BA.debugLine="If googleparser.Parents.IndexOf(\"PostalCode\") > -1 Then		'postcode'";
if (_googleparser.Parents.IndexOf((Object)("PostalCode"))>(int)(-1)) { 
 BA.debugLineNum = 172;BA.debugLine="If Name = \"PostalCodeNumber\" Then";
if ((_name).equals("PostalCodeNumber")) { 
 BA.debugLineNum = 173;BA.debugLine="postcode=Text.ToString";
_postcode = _text.ToString();
 BA.debugLineNum = 174;BA.debugLine="End If";
};
 BA.debugLineNum = 175;BA.debugLine="End If";
};
 BA.debugLineNum = 176;BA.debugLine="End If";
};
 BA.debugLineNum = 177;BA.debugLine="End Sub";
return "";
}
public static String  _gps_locationchanged(anywheresoftware.b4a.gps.LocationWrapper _location1) throws Exception{
 BA.debugLineNum = 83;BA.debugLine="Lat =  Location1.Latitude";
_lat = _location1.getLatitude();
 BA.debugLineNum = 84;BA.debugLine="Lon =  Location1.Longitude";
_lon = _location1.getLongitude();
 BA.debugLineNum = 85;BA.debugLine="Course = Location1.Bearing";
_course = _location1.getBearing();
 BA.debugLineNum = 86;BA.debugLine="End Sub";
return "";
}
public static String  _gps_userenabled(boolean _enabled) throws Exception{
 BA.debugLineNum = 80;BA.debugLine="ToastMessageShow(\"GPS device enabled = \" & Enabled, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("GPS device enabled = "+String.valueOf(_enabled),anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
public static String  _gpsinfo_click() throws Exception{
String _thing = "";
main._wiki _thingy = null;
anywheresoftware.b4a.keywords.StringBuilderWrapper _thingame = null;
int _i = 0;
 BA.debugLineNum = 220;BA.debugLine="googlemsgbox=\"Google\" & CRLF & \"Country: \" & googlecountry & CRLF & \"Administrative Area: \" & administrativearea & CRLF & \"Sub Administrative Area: \" & subadministrativearea & CRLF & \"PostCode: \" & postcode & CRLF & \"Locality: \" & localityname & CRLF & \"Street, Number: \" & googleStreet & CRLF & CRLF";
_googlemsgbox = "Google"+anywheresoftware.b4a.keywords.Common.CRLF+"Country: "+_googlecountry+anywheresoftware.b4a.keywords.Common.CRLF+"Administrative Area: "+_administrativearea+anywheresoftware.b4a.keywords.Common.CRLF+"Sub Administrative Area: "+_subadministrativearea+anywheresoftware.b4a.keywords.Common.CRLF+"PostCode: "+_postcode+anywheresoftware.b4a.keywords.Common.CRLF+"Locality: "+_localityname+anywheresoftware.b4a.keywords.Common.CRLF+"Street, Number: "+_googlestreet+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF;
 BA.debugLineNum = 221;BA.debugLine="yahoomsgbox=\"Yahoo\" & CRLF & \"Street or Townland: \" & yahoostreet & CRLF & \"City: \" & city & CRLF & county & CRLF & \"Country: \" & yahoocountry & CRLF & \"Neighbourhood: \" & neighborhood & CRLF &  CRLF";
_yahoomsgbox = "Yahoo"+anywheresoftware.b4a.keywords.Common.CRLF+"Street or Townland: "+_yahoostreet+anywheresoftware.b4a.keywords.Common.CRLF+"City: "+_city+anywheresoftware.b4a.keywords.Common.CRLF+_county+anywheresoftware.b4a.keywords.Common.CRLF+"Country: "+_yahoocountry+anywheresoftware.b4a.keywords.Common.CRLF+"Neighbourhood: "+_neighborhood+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF;
 BA.debugLineNum = 222;BA.debugLine="Dim thing As String";
_thing = "";
 BA.debugLineNum = 223;BA.debugLine="Dim thingy As wiki";
_thingy = new main._wiki();
 BA.debugLineNum = 224;BA.debugLine="Dim thingame As StringBuilder";
_thingame = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 BA.debugLineNum = 225;BA.debugLine="thingame.Initialize";
_thingame.Initialize();
 BA.debugLineNum = 226;BA.debugLine="thingame.Append(\"Local Landmarks from wikipedia\")";
_thingame.Append("Local Landmarks from wikipedia");
 BA.debugLineNum = 227;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 228;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 229;BA.debugLine="For i=0 To Adrlist.Size-1";
{
final double step217 = 1;
final double limit217 = (int)(_adrlist.getSize()-1);
for (_i = (int)(0); (step217 > 0 && _i <= limit217) || (step217 < 0 && _i >= limit217); _i += step217) {
 BA.debugLineNum = 230;BA.debugLine="thingy=adrlist.Get(i)";
_thingy = (main._wiki)(_adrlist.Get(_i));
 BA.debugLineNum = 231;BA.debugLine="thingame.Append(thingy.title)";
_thingame.Append(_thingy.title);
 BA.debugLineNum = 232;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 233;BA.debugLine="thingame.Append(\"distance from: \")";
_thingame.Append("distance from: ");
 BA.debugLineNum = 234;BA.debugLine="thingame.Append(thingy.distance)";
_thingame.Append(_thingy.distance);
 BA.debugLineNum = 235;BA.debugLine="thingame.Append(\"km\")";
_thingame.Append("km");
 BA.debugLineNum = 236;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 237;BA.debugLine="thingame.Append(thingy.summary)";
_thingame.Append(_thingy.summary);
 BA.debugLineNum = 238;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 239;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 240;BA.debugLine="Next";
}
};
 BA.debugLineNum = 241;BA.debugLine="thingame.Append(\"Co-ordinates\")";
_thingame.Append("Co-ordinates");
 BA.debugLineNum = 242;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 243;BA.debugLine="thingame.Append(\"Latitude: \")";
_thingame.Append("Latitude: ");
 BA.debugLineNum = 244;BA.debugLine="thingame.Append(lat)";
_thingame.Append(BA.NumberToString(_lat));
 BA.debugLineNum = 245;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 246;BA.debugLine="thingame.Append(\"Longitude: \")";
_thingame.Append("Longitude: ");
 BA.debugLineNum = 247;BA.debugLine="thingame.Append(lon)";
_thingame.Append(BA.NumberToString(_lon));
 BA.debugLineNum = 248;BA.debugLine="thingame.Append(CRLF)";
_thingame.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 BA.debugLineNum = 249;BA.debugLine="thing=thingame.ToString";
_thing = _thingame.ToString();
 BA.debugLineNum = 250;BA.debugLine="Msgbox(googlemsgbox & yahoomsgbox & thing,\"Townlands\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_googlemsgbox+_yahoomsgbox+_thing,"Townlands",mostCurrent.activityBA);
 BA.debugLineNum = 251;BA.debugLine="End Sub";
return "";
}
public static String  _help_click() throws Exception{
 BA.debugLineNum = 365;BA.debugLine="Msgbox(\"The menu buttons are toggle switches which will alternate between google/yahoo, as the geocode servers for the main screen, text to speech off/on, and mirrored text off/on.\" & CRLF & \"The mirrored text is to enable viewing the phone on a car windscreen if the phone was placed underneath it.\" & CRLF & \"Don't forget to check out 'full info' for the full information from three reverse geocode servers, including wikipedia information via geonames.\" & CRLF & CRLF & \"This has been designed as a practical app to use your GPS when driving if you don't wish to view a map. It will pull your co-ordinates from the GPS and send them over a network (which must be switched on) to geocode servers to translate the co-ordinates into a street or, in Ireland, townland name.\" & CRLF & CRLF & \"If you like it you can check out the books by Brian Nugent on amazon.com and most online book sellers.\",\"Help/About\")";
anywheresoftware.b4a.keywords.Common.Msgbox("The menu buttons are toggle switches which will alternate between google/yahoo, as the geocode servers for the main screen, text to speech off/on, and mirrored text off/on."+anywheresoftware.b4a.keywords.Common.CRLF+"The mirrored text is to enable viewing the phone on a car windscreen if the phone was placed underneath it."+anywheresoftware.b4a.keywords.Common.CRLF+"Don't forget to check out 'full info' for the full information from three reverse geocode servers, including wikipedia information via geonames."+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF+"This has been designed as a practical app to use your GPS when driving if you don't wish to view a map. It will pull your co-ordinates from the GPS and send them over a network (which must be switched on) to geocode servers to translate the co-ordinates into a street or, in Ireland, townland name."+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF+"If you like it you can check out the books by Brian Nugent on amazon.com and most online book sellers.","Help/About",mostCurrent.activityBA);
 BA.debugLineNum = 366;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientgeonames_responseerror(String _reason,int _statuscode,int _taskid) throws Exception{
 BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientgeonames_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
 BA.debugLineNum = 136;BA.debugLine="geonamesResult=response.GetInputStream";
_geonamesresult = _response.GetInputStream();
 BA.debugLineNum = 137;BA.debugLine="geonamesparser.Parse(geonamesResult, \"geonamesparser\")";
_geonamesparser.Parse((java.io.InputStream)(_geonamesresult.getObject()),"geonamesparser");
 BA.debugLineNum = 138;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientgoogle_responseerror(String _reason,int _statuscode,int _taskid) throws Exception{
 BA.debugLineNum = 118;BA.debugLine="ToastMessageShow(\"Google http error: \" & Reason & \". Better check If the Network Connection Is Ok.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Google http error: "+_reason+". Better check If the Network Connection Is Ok.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 119;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientgoogle_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
 BA.debugLineNum = 128;BA.debugLine="googleResult=response.GetInputStream";
_googleresult = _response.GetInputStream();
 BA.debugLineNum = 129;BA.debugLine="googleparser.Parse(googleResult, \"googleparser\")";
_googleparser.Parse((java.io.InputStream)(_googleresult.getObject()),"googleparser");
 BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientyahoo_responseerror(String _reason,int _statuscode,int _taskid) throws Exception{
 BA.debugLineNum = 121;BA.debugLine="ToastMessageShow(\"Yahoo http error:\" & Reason & \". Better check if the Network Connection is Ok.\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Yahoo http error:"+_reason+". Better check if the Network Connection is Ok.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public static String  _httpclientyahoo_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
 BA.debugLineNum = 132;BA.debugLine="yahooResult=response.GetInputStream";
_yahooresult = _response.GetInputStream();
 BA.debugLineNum = 133;BA.debugLine="yahooparser.Parse(yahooResult, \"yahooparser\")";
_yahooparser.Parse((java.io.InputStream)(_yahooresult.getObject()),"yahooparser");
 BA.debugLineNum = 134;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 5;BA.debugLine="Dim timer2 As Timer";
_timer2 = new anywheresoftware.b4a.objects.Timer();
 BA.debugLineNum = 6;BA.debugLine="Dim gps1 As GPS";
_gps1 = new anywheresoftware.b4a.gps.GPS();
 BA.debugLineNum = 7;BA.debugLine="Dim Lat, Lon, Course As Double";
_lat = 0;
_lon = 0;
_course = 0;
 BA.debugLineNum = 10;BA.debugLine="Dim googleURL, yahooURL, geonamesURL, googlecountry, yahoocountry,state, circle, postcode, place, googlestreet, yahoostreet As String";
_googleurl = "";
_yahoourl = "";
_geonamesurl = "";
_googlecountry = "";
_yahoocountry = "";
_state = "";
_circle = "";
_postcode = "";
_place = "";
_googlestreet = "";
_yahoostreet = "";
 BA.debugLineNum = 11;BA.debugLine="Dim HTTPClientgoogle,HTTPClientyahoo,HTTPClientgeonames As HttpClient";
_httpclientgoogle = new anywheresoftware.b4a.http.HttpClientWrapper();
_httpclientyahoo = new anywheresoftware.b4a.http.HttpClientWrapper();
_httpclientgeonames = new anywheresoftware.b4a.http.HttpClientWrapper();
 BA.debugLineNum = 12;BA.debugLine="Dim googleparser As SaxParser";
_googleparser = new anywheresoftware.b4a.objects.SaxParser();
 BA.debugLineNum = 13;BA.debugLine="Dim yahooparser As SaxParser";
_yahooparser = new anywheresoftware.b4a.objects.SaxParser();
 BA.debugLineNum = 14;BA.debugLine="Dim geonamesparser As SaxParser";
_geonamesparser = new anywheresoftware.b4a.objects.SaxParser();
 BA.debugLineNum = 15;BA.debugLine="Dim googleResult,yahooResult,geonamesResult As InputStream";
_googleresult = new anywheresoftware.b4a.objects.streams.File.InputStreamWrapper();
_yahooresult = new anywheresoftware.b4a.objects.streams.File.InputStreamWrapper();
_geonamesresult = new anywheresoftware.b4a.objects.streams.File.InputStreamWrapper();
 BA.debugLineNum = 16;BA.debugLine="Dim Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 BA.debugLineNum = 17;BA.debugLine="Dim address As String";
_address = "";
 BA.debugLineNum = 18;BA.debugLine="Dim googlemsgbox As String";
_googlemsgbox = "";
 BA.debugLineNum = 19;BA.debugLine="Dim yahoomsgbox As String";
_yahoomsgbox = "";
 BA.debugLineNum = 20;BA.debugLine="Dim subadministrativearea,administrativearea,localityname,county,city,neighborhood,countrycode As String";
_subadministrativearea = "";
_administrativearea = "";
_localityname = "";
_county = "";
_city = "";
_neighborhood = "";
_countrycode = "";
 BA.debugLineNum = 21;BA.debugLine="Type wiki(title As String, distance As String, summary As String)";
;
 BA.debugLineNum = 22;BA.debugLine="Dim adrlist As List";
_adrlist = new anywheresoftware.b4a.objects.collections.List();
 BA.debugLineNum = 23;BA.debugLine="Dim tts1 As TTS";
_tts1 = new anywheresoftware.b4a.obejcts.TTS();
 BA.debugLineNum = 24;BA.debugLine="Dim spokenword As String";
_spokenword = "";
 BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _quit_click() throws Exception{
 BA.debugLineNum = 384;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 BA.debugLineNum = 386;BA.debugLine="End Sub";
return "";
}
public static String  _reversestring(String _stringtobeworkedon) throws Exception{
int _i = 0;
int _i2 = 0;
String _s = "";
 BA.debugLineNum = 368;BA.debugLine="Dim i As Int";
_i = 0;
 BA.debugLineNum = 369;BA.debugLine="Dim i2 As Int";
_i2 = 0;
 BA.debugLineNum = 370;BA.debugLine="Dim s As String";
_s = "";
 BA.debugLineNum = 372;BA.debugLine="For i=stringtobeworkedon.Length-1 To 0 Step -1";
{
final double step359 = -1;
final double limit359 = (int)(0);
for (_i = (int)(_stringtobeworkedon.length()-1); (step359 > 0 && _i <= limit359) || (step359 < 0 && _i >= limit359); _i += step359) {
 BA.debugLineNum = 374;BA.debugLine="s=s & stringtobeworkedon.CharAt(i)";
_s = _s+String.valueOf(_stringtobeworkedon.charAt(_i));
 BA.debugLineNum = 375;BA.debugLine="Next";
}
};
 BA.debugLineNum = 376;BA.debugLine="Return s";
if (true) return _s;
 BA.debugLineNum = 377;BA.debugLine="End Sub";
return "";
}
public static String  _settings_click() throws Exception{
String _geocodename = "";
 BA.debugLineNum = 335;BA.debugLine="Dim geocodename As String";
_geocodename = "";
 BA.debugLineNum = 336;BA.debugLine="geocodename=File.GetText(File.DirInternal,\"settings.txt\")";
_geocodename = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.txt");
 BA.debugLineNum = 337;BA.debugLine="If geocodename=\"yahoo\" Then";
if ((_geocodename).equals("yahoo")) { 
 BA.debugLineNum = 338;BA.debugLine="File.WriteString(File.DirInternal,\"settings.txt\",\"google\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.txt","google");
 BA.debugLineNum = 339;BA.debugLine="End If";
};
 BA.debugLineNum = 340;BA.debugLine="If geocodename=\"google\" Then";
if ((_geocodename).equals("google")) { 
 BA.debugLineNum = 341;BA.debugLine="File.WriteString(File.DirInternal,\"settings.txt\",\"yahoo\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.txt","yahoo");
 BA.debugLineNum = 342;BA.debugLine="End If";
};
 BA.debugLineNum = 343;BA.debugLine="End Sub";
return "";
}
public static String  _settings2_click() throws Exception{
String _fonttype = "";
 BA.debugLineNum = 345;BA.debugLine="Dim fonttype As String";
_fonttype = "";
 BA.debugLineNum = 346;BA.debugLine="fonttype=File.GetText(File.DirInternal,\"fonttype.txt\")";
_fonttype = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"fonttype.txt");
 BA.debugLineNum = 347;BA.debugLine="If fonttype=\"backwards\" Then";
if ((_fonttype).equals("backwards")) { 
 BA.debugLineNum = 348;BA.debugLine="File.WriteString(File.DirInternal,\"fonttype.txt\",\"forwards\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"fonttype.txt","forwards");
 BA.debugLineNum = 349;BA.debugLine="End If";
};
 BA.debugLineNum = 350;BA.debugLine="If fonttype=\"forwards\" Then";
if ((_fonttype).equals("forwards")) { 
 BA.debugLineNum = 351;BA.debugLine="File.WriteString(File.DirInternal,\"fonttype.txt\",\"backwards\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"fonttype.txt","backwards");
 BA.debugLineNum = 352;BA.debugLine="End If";
};
 BA.debugLineNum = 353;BA.debugLine="End Sub";
return "";
}
public static String  _settings3_click() throws Exception{
String _voicesetting = "";
 BA.debugLineNum = 355;BA.debugLine="Dim voicesetting As String";
_voicesetting = "";
 BA.debugLineNum = 356;BA.debugLine="voicesetting=File.GetText(File.DirInternal,\"voice.txt\")";
_voicesetting = anywheresoftware.b4a.keywords.Common.File.GetText(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"voice.txt");
 BA.debugLineNum = 357;BA.debugLine="If voicesetting=\"on\" Then";
if ((_voicesetting).equals("on")) { 
 BA.debugLineNum = 358;BA.debugLine="File.WriteString(File.DirInternal,\"voice.txt\",\"off\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"voice.txt","off");
 BA.debugLineNum = 359;BA.debugLine="End If";
};
 BA.debugLineNum = 360;BA.debugLine="If voicesetting=\"off\" Then";
if ((_voicesetting).equals("off")) { 
 BA.debugLineNum = 361;BA.debugLine="File.WriteString(File.DirInternal,\"voice.txt\",\"on\")";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"voice.txt","on");
 BA.debugLineNum = 362;BA.debugLine="End If";
};
 BA.debugLineNum = 363;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _requestgoogle = null;
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _requestyahoo = null;
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _requestgeonames = null;
 BA.debugLineNum = 94;BA.debugLine="googleURL = \"http://maps.google.com/maps/geo?output=xml&oe=utf-8&ll=\" & lat & \",\" & lon & \"&key=asdad\"";
_googleurl = "http://maps.google.com/maps/geo?output=xml&oe=utf-8&ll="+BA.NumberToString(_lat)+","+BA.NumberToString(_lon)+"&key=asdad";
 BA.debugLineNum = 95;BA.debugLine="yahooURL = \"http://where.yahooapis.com/geocode?q=\" & lat & \",\" & lon & \"&gflags=R\"";
_yahoourl = "http://where.yahooapis.com/geocode?q="+BA.NumberToString(_lat)+","+BA.NumberToString(_lon)+"&gflags=R";
 BA.debugLineNum = 96;BA.debugLine="geonamesURL = \"http://ws.geonames.org/findNearbyWikipedia?lat=\" & lat & \"&lng=\" & lon";
_geonamesurl = "http://ws.geonames.org/findNearbyWikipedia?lat="+BA.NumberToString(_lat)+"&lng="+BA.NumberToString(_lon);
 BA.debugLineNum = 97;BA.debugLine="Dim requestgoogle As HttpRequest";
_requestgoogle = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 BA.debugLineNum = 98;BA.debugLine="requestgoogle.InitializeGet(googleURL)";
_requestgoogle.InitializeGet(_googleurl);
 BA.debugLineNum = 99;BA.debugLine="Dim requestyahoo As HttpRequest";
_requestyahoo = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 BA.debugLineNum = 100;BA.debugLine="requestyahoo.InitializeGet(yahooURL)";
_requestyahoo.InitializeGet(_yahoourl);
 BA.debugLineNum = 101;BA.debugLine="Dim requestgeonames As HttpRequest";
_requestgeonames = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 BA.debugLineNum = 102;BA.debugLine="requestgeonames.InitializeGet(geonamesURL)";
_requestgeonames.InitializeGet(_geonamesurl);
 BA.debugLineNum = 103;BA.debugLine="requestgoogle.Timeout = 10000 'set timeout to 10 seconds";
_requestgoogle.setTimeout((int)(10000));
 BA.debugLineNum = 104;BA.debugLine="requestyahoo.Timeout = 10000";
_requestyahoo.setTimeout((int)(10000));
 BA.debugLineNum = 105;BA.debugLine="requestgeonames.Timeout = 100000";
_requestgeonames.setTimeout((int)(100000));
 BA.debugLineNum = 106;BA.debugLine="If HttpClientgoogle.Execute(requestgoogle, 1) = False Then";
if (_httpclientgoogle.Execute(processBA,_requestgoogle,(int)(1))==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 107;BA.debugLine="Return 'Will be false if there is already a running task (with the same id).";
if (true) return "";
 BA.debugLineNum = 108;BA.debugLine="End If";
};
 BA.debugLineNum = 109;BA.debugLine="If HttpClientyahoo.Execute(requestyahoo, 1) = False Then";
if (_httpclientyahoo.Execute(processBA,_requestyahoo,(int)(1))==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 110;BA.debugLine="Return 'Will be false if there is already a running task (with the same id).";
if (true) return "";
 BA.debugLineNum = 111;BA.debugLine="End If";
};
 BA.debugLineNum = 112;BA.debugLine="If HttpClientgeonames.Execute(requestgeonames, 1) = False Then";
if (_httpclientgeonames.Execute(processBA,_requestgeonames,(int)(1))==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 113;BA.debugLine="Return 'Will be false if there is already a running task (with the same id).";
if (true) return "";
 BA.debugLineNum = 114;BA.debugLine="End If";
};
 BA.debugLineNum = 115;BA.debugLine="Gettextsize";
_gettextsize();
 BA.debugLineNum = 116;BA.debugLine="End Sub";
return "";
}
public static String  _tts1_ready(boolean _success) throws Exception{
 BA.debugLineNum = 88;BA.debugLine="If Success Then";
if (_success) { 
 BA.debugLineNum = 89;BA.debugLine="Else";
}else {
 BA.debugLineNum = 90;BA.debugLine="Msgbox(\"Error initializing TTS engine.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Error initializing TTS engine.","",mostCurrent.activityBA);
 BA.debugLineNum = 91;BA.debugLine="End If";
};
 BA.debugLineNum = 92;BA.debugLine="End Sub";
return "";
}
public static String  _yahooparser_endelement(String _uri,String _name,anywheresoftware.b4a.keywords.StringBuilderWrapper _text) throws Exception{
 BA.debugLineNum = 179;BA.debugLine="If yahooparser.Parents.IndexOf(\"Result\") > -1 Then";
if (_yahooparser.Parents.IndexOf((Object)("Result"))>(int)(-1)) { 
 BA.debugLineNum = 180;BA.debugLine="If Name = \"country\" Then";
if ((_name).equals("country")) { 
 BA.debugLineNum = 181;BA.debugLine="yahoocountry=Text.ToString";
_yahoocountry = _text.ToString();
 BA.debugLineNum = 182;BA.debugLine="End If";
};
 BA.debugLineNum = 183;BA.debugLine="If Name = \"county\" Then";
if ((_name).equals("county")) { 
 BA.debugLineNum = 184;BA.debugLine="county=Text.ToString";
_county = _text.ToString();
 BA.debugLineNum = 185;BA.debugLine="End If";
};
 BA.debugLineNum = 186;BA.debugLine="If Name = \"city\" Then";
if ((_name).equals("city")) { 
 BA.debugLineNum = 187;BA.debugLine="city=Text.ToString";
_city = _text.ToString();
 BA.debugLineNum = 188;BA.debugLine="End If";
};
 BA.debugLineNum = 189;BA.debugLine="If Name = \"neighborhood\" Then";
if ((_name).equals("neighborhood")) { 
 BA.debugLineNum = 190;BA.debugLine="neighborhood=Text.ToString";
_neighborhood = _text.ToString();
 BA.debugLineNum = 191;BA.debugLine="End If";
};
 BA.debugLineNum = 192;BA.debugLine="If Name = \"street\" Then";
if ((_name).equals("street")) { 
 BA.debugLineNum = 193;BA.debugLine="yahoostreet=Text.ToString";
_yahoostreet = _text.ToString();
 BA.debugLineNum = 194;BA.debugLine="End If";
};
 BA.debugLineNum = 195;BA.debugLine="If Name = \"countrycode\" Then";
if ((_name).equals("countrycode")) { 
 BA.debugLineNum = 196;BA.debugLine="countrycode=Text.ToString";
_countrycode = _text.ToString();
 BA.debugLineNum = 197;BA.debugLine="End If";
};
 BA.debugLineNum = 198;BA.debugLine="End If";
};
 BA.debugLineNum = 199;BA.debugLine="End Sub";
return "";
}
}
